

#include "BUILTIN.h"

#include "Array.h"

#include "Nat.h"
extern OBJ __ASeq_6;
extern OBJ _ASeq_14(OBJ,OBJ);extern OBJ __ASeq_14;
extern OBJ _ASeq_15(OBJ,OBJ,OBJ);extern OBJ __ASeq_15;
extern OBJ _ASeq_24(OBJ,OBJ,OBJ);extern OBJ __ASeq_24;
extern OBJ _ASeq_26(OBJ,OBJ);extern OBJ __ASeq_26;
extern OBJ _ASeq_31(OBJ,OBJ);extern OBJ __ASeq_31;
extern OBJ _ASeq_32(OBJ,OBJ);extern OBJ __ASeq_32;
extern OBJ _ASeq_52(OBJ,OBJ);extern OBJ __ASeq_52;

#include "Char.h"

#include "Int.h"
extern OBJ _ASeqMap_3(OBJ,OBJ);extern OBJ __ASeqMap_3;
extern OBJ _ASeqZip_4(OBJ,OBJ,OBJ);extern OBJ __ASeqZip_4;
extern OBJ __AStore_12;
extern OBJ __AStore_32;
extern OBJ __AMacros_9;
extern OBJ _AMacros_12(OBJ);extern OBJ __AMacros_12;
extern OBJ _AMacros_18(OBJ,OBJ);extern OBJ __AMacros_18;
extern OBJ __AMacros_22;
extern OBJ _AMacros_33(OBJ,OBJ,OBJ);extern OBJ __AMacros_33;
extern OBJ _AMacros_42(OBJ,OBJ);extern OBJ __AMacros_42;
extern OBJ _AMacros_47(OBJ,OBJ,OBJ);extern OBJ __AMacros_47;
extern OBJ _AMacros_49(OBJ,OBJ);extern OBJ __AMacros_49;
extern OBJ _AMacros_50(OBJ,OBJ,OBJ);extern OBJ __AMacros_50;
extern OBJ _AMacros_51(OBJ,OBJ);extern OBJ __AMacros_51;
extern OBJ _AMacros_52(OBJ,OBJ,OBJ);extern OBJ __AMacros_52;
extern OBJ _AMacros_59(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __AMacros_59;
extern OBJ _AMacros_74(OBJ,OBJ,OBJ);extern OBJ __AMacros_74;
extern OBJ _AMacros_75(OBJ);extern OBJ __AMacros_75;
extern OBJ _AMacros_76(OBJ,OBJ);extern OBJ __AMacros_76;
extern OBJ _AMacros_77(OBJ,OBJ);extern OBJ __AMacros_77;
extern OBJ _AMacros_78(OBJ,OBJ,OBJ);extern OBJ __AMacros_78;
extern OBJ _AMacros_79(OBJ,OBJ,OBJ);extern OBJ __AMacros_79;
extern OBJ _AMacros_80(OBJ,OBJ);extern OBJ __AMacros_80;
extern OBJ __AMacros_81;
extern OBJ _AMacros_82(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMacros_82;
extern OBJ _AMacros_83(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMacros_83;
extern OBJ __AMacros_141;

#include "Bitset.h"
extern OBJ _AGenEvalMethod_1(OBJ,OBJ);OBJ __AGenEvalMethod_1; /* genEvalMethod */
extern OBJ _AGenEvalMethod_2(OBJ,OBJ);OBJ __AGenEvalMethod_2; /* genEvalMethodTabInit */
extern OBJ _AGenEvalMethod_4(OBJ,OBJ,OBJ);OBJ __AGenEvalMethod_4; /* genUnderfullMethod */
extern OBJ _AGenEvalMethod_5(OBJ,OBJ,OBJ);OBJ __AGenEvalMethod_5; /* genOverfullMethod */
extern OBJ _AGenEvalMethod_6(OBJ,OBJ,OBJ);OBJ __AGenEvalMethod_6; /* genFullMethod */
extern OBJ _AGenEvalMethod_7(OBJ,OBJ,OBJ);OBJ __AGenEvalMethod_7; /* genPlainFullMethod */
extern OBJ _AGenEvalMethod_8(OBJ,OBJ,OBJ);OBJ __AGenEvalMethod_8; /* genLazyFullMethod */
extern OBJ _AGenEvalMethod_9(OBJ);OBJ __AGenEvalMethod_9; /* cCopy1 */
extern OBJ _AGenEvalMethod_10(OBJ);OBJ __AGenEvalMethod_10; /* genUnderfullMethod'10 */
extern OBJ _AGenEvalMethod_11(OBJ);OBJ __AGenEvalMethod_11; /* genUnderfullMethod'11 */
extern OBJ _AGenEvalMethod_12(OBJ);OBJ __AGenEvalMethod_12; /* genUnderfullMethod'12 */
extern OBJ _AGenEvalMethod_13(OBJ);OBJ __AGenEvalMethod_13; /* genUnderfullMethod'13 */
extern OBJ _AGenEvalMethod_14(OBJ);OBJ __AGenEvalMethod_14; /* genUnderfullMethod'14 */
extern OBJ _AGenEvalMethod_15(OBJ);OBJ __AGenEvalMethod_15; /* genUnderfullMethod'15 */
extern OBJ _AGenEvalMethod_16(OBJ);OBJ __AGenEvalMethod_16; /* genUnderfullMethod'16 */
extern OBJ _AGenEvalMethod_17(OBJ,OBJ);OBJ __AGenEvalMethod_17; /* genUnderfullMethod'17 */
extern OBJ _AGenEvalMethod_18(OBJ);OBJ __AGenEvalMethod_18; /* genUnderfullMethod'18 */
extern OBJ _AGenEvalMethod_19(OBJ);OBJ __AGenEvalMethod_19; /* genUnderfullMethod'19 */
OBJ __AGenEvalMethod_20; /* genUnderfullMethod'20 */
extern OBJ _AGenEvalMethod_21(OBJ);OBJ __AGenEvalMethod_21; /* genOverfullMethod'21 */
extern OBJ _AGenEvalMethod_22(OBJ);OBJ __AGenEvalMethod_22; /* genOverfullMethod'22 */
extern OBJ _AGenEvalMethod_23(OBJ);OBJ __AGenEvalMethod_23; /* genOverfullMethod'23 */
extern OBJ _AGenEvalMethod_24(OBJ);OBJ __AGenEvalMethod_24; /* genOverfullMethod'24 */
extern OBJ _AGenEvalMethod_25(OBJ,OBJ);OBJ __AGenEvalMethod_25; /* genOverfullMethod'25 */
extern OBJ _AGenEvalMethod_26(OBJ);OBJ __AGenEvalMethod_26; /* genOverfullMethod'26 */
extern OBJ _AGenEvalMethod_27(OBJ);OBJ __AGenEvalMethod_27; /* genOverfullMethod'27 */
extern OBJ _AGenEvalMethod_28(OBJ);OBJ __AGenEvalMethod_28; /* genPlainFullMethod'28 */
extern OBJ _AGenEvalMethod_29(OBJ);OBJ __AGenEvalMethod_29; /* genPlainFullMethod'29 */
extern OBJ _AGenEvalMethod_30(OBJ);OBJ __AGenEvalMethod_30; /* genPlainFullMethod'30 */
extern OBJ _AGenEvalMethod_31(OBJ);OBJ __AGenEvalMethod_31; /* genPlainFullMethod'31 */
extern OBJ _AGenEvalMethod_32(OBJ,OBJ);OBJ __AGenEvalMethod_32; /* genPlainFullMethod'32 */
extern OBJ _AGenEvalMethod_33(OBJ);OBJ __AGenEvalMethod_33; /* genPlainFullMethod'33 */
extern OBJ _AGenEvalMethod_34(OBJ);OBJ __AGenEvalMethod_34; /* genPlainFullMethod'34 */
extern OBJ _AGenEvalMethod_35(OBJ);OBJ __AGenEvalMethod_35; /* genLazyFullMethod'35 */
extern OBJ _AGenEvalMethod_36(OBJ);OBJ __AGenEvalMethod_36; /* genLazyFullMethod'36 */
extern OBJ _AGenEvalMethod_37(OBJ);OBJ __AGenEvalMethod_37; /* genLazyFullMethod'37 */
extern OBJ _AGenEvalMethod_38(OBJ);OBJ __AGenEvalMethod_38; /* genLazyFullMethod'38 */
extern OBJ _AGenEvalMethod_39(OBJ);OBJ __AGenEvalMethod_39; /* genLazyFullMethod'39 */
extern OBJ _AGenEvalMethod_40(OBJ);OBJ __AGenEvalMethod_40; /* genLazyFullMethod'40 */
extern OBJ _AGenEvalMethod_41(OBJ,OBJ);OBJ __AGenEvalMethod_41; /* genLazyFullMethod'41 */
extern OBJ _AGenEvalMethod_42(OBJ);OBJ __AGenEvalMethod_42; /* genLazyFullMethod'42 */
extern OBJ _AGenEvalMethod_43(OBJ);OBJ __AGenEvalMethod_43; /* genLazyFullMethod'43 */
extern OBJ _AGenEvalMethod_44(OBJ);OBJ __AGenEvalMethod_44; /* genLazyFullMethod'44 */
extern OBJ _AGenEvalMethod_45(OBJ);OBJ __AGenEvalMethod_45; /* genLazyFullMethod'45 */

extern OBJ _AGenEvalMethod_1(OBJ x1,OBJ x2) /* genEvalMethod */
{OBJ r;
 FRPRD(x1,1);
 {OBJ x18=FLD1(x2,1);OBJ x19=FLD1(x2,2);OBJ x20=FLD1(x2,3);
  if(EXPRD(x2,1)){
   DSPRDF(x2);
  }else{
   FRPRD(x2,1);}
  {OBJ x21;OBJ x22;
   ANat_61(x19,x20,x21);
   ANat_80(x21,x18,x22);
   if(ISTGPRM(x22,1)){
    r=_AGenEvalMethod_4(x18,x19,x20);
   }else{
    {OBJ x23;
     ANat_81(x21,x18,x23);
     if(ISTGPRM(x23,1)){
      r=_AGenEvalMethod_5(x18,x19,x20);
     }else{
      r=_AGenEvalMethod_6(x18,x19,x20);}}}}}
 return r;}

extern OBJ _AGenEvalMethod_2(OBJ x1,OBJ x2) /* genEvalMethodTabInit */
{OBJ r;
 FRPRD(x1,1);
 {OBJ x24=FLD1(x2,1);OBJ x25=FLD1(x2,2);OBJ x26=FLD1(x2,3);
  if(EXPRD(x2,1)){
   DSPRDF(x2);
  }else{
   FRPRD(x2,1);}
  {OBJ x27;OBJ x28;OBJ x29;OBJ x30;OBJ x31;OBJ x33;OBJ x34;
   ANat_61(x25,x26,x27);
   x28=_AMacros_74(x24,x25,x26);
   CPPRD(x28,1);
   x29=_AMacros_82(x24,x25,x26,x28);
   ANat_76(x27,x24,x30);
   if(ISTGPRM(x30,1)){
    ANat_76(x26,__ANat_8,x31);
   }else{
    x31=__ABUILTIN_3;}
   if(ISTGPRM(x31,1)){
    CPPRD(__AMacros_81,1);
    {OBJ x32;
     x32=_ASeq_14(x28,__AMacros_81);
     PRD(1,2,x33);FLD(x33,1)=x32;}
   }else{
    x33=x28;}
   x34=_AMacros_83(x24,x25,x26,x33);
   PRD(1,2,r);
   FLD(r,1)=_ASeq_14(x29,x34);}}
 return r;}

extern OBJ _AGenEvalMethod_4(OBJ x1,OBJ x2,OBJ x3) /* genUnderfullMethod */
{OBJ r;
 CPCLS(__AGenEvalMethod_9,1);
 CPCLS(__AGenEvalMethod_10,1);
 CPCLS(__AGenEvalMethod_11,1);
 CPCLS(__AGenEvalMethod_12,1);
 CPCLS(__AGenEvalMethod_13,1);
 CPCLS(__AGenEvalMethod_14,1);
 CPCLS(__AGenEvalMethod_15,1);
 CPCLS(__AGenEvalMethod_16,1);
 CPCLS(__AGenEvalMethod_17,1);
 CPPRD(__AMacros_9,1);
 CPCLS(__AMacros_12,1);
 CPCLS(__AMacros_42,2);
 {OBJ x4;OBJ x5;OBJ x6;OBJ x7;OBJ x8;OBJ x9;OBJ x10;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;OBJ x16;OBJ x17;OBJ x18;OBJ x19;OBJ x20;OBJ x21;OBJ x22;OBJ x23;OBJ x24;OBJ x25;OBJ x26;OBJ x27;OBJ x30;OBJ x31;OBJ x32;
  x4=_AMacros_78(__AMacros_9,x2,x3);
  ANat_2(x2,x5);
  x6=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_13,1))(__AGenEvalMethod_13,__ABUILTIN_20);
  CPPRD(x6,1);
  ANat_76(x2,__ANat_5,x7);
  x8=_AMacros_74(x1,x2,x3);
  x9=_ASeq_24(__ANat_8,x2,__AGenEvalMethod_10);
  COPY(x9,1);
  x10=_ASeq_24(__ANat_8,x3,__AGenEvalMethod_11);
  x11=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_16,1))(__AGenEvalMethod_16,__ABUILTIN_20);
  x12=_ASeqMap_3(__AGenEvalMethod_14,x9);
  COPY(x12,1);
  x13=_ASeqMap_3(__AMacros_12,x10);
  COPY(x13,2);
  x14=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_17,1))(__AGenEvalMethod_17,x6);
  x15=_ASeqMap_3(__AGenEvalMethod_9,x12);
  x16=_ASeq_52(x13,__ANat_5);
  x17=_ASeqMap_3(x14,x9);
  PRD1(2,x18);FLD1(x18,1)=x6;FLD1(x18,2)=x13;
  ANat_61(x2,x16,x19);
  x20=_ASeqZip_4(__AMacros_42,x17,x12);
  x21=_ASeq_24(x5,x19,__AGenEvalMethod_12);
  x22=_ASeq_26(x20,x15);
  x23=_ASeqMap_3(__AGenEvalMethod_15,x21);
  PRD1(2,x24);FLD1(x24,1)=x11;FLD1(x24,2)=x22;
  x25=_ASeqZip_4(__AMacros_42,x13,x23);
  x26=_AMacros_51(__ASeq_6,x24);
  PRD1(2,x27);FLD1(x27,1)=x4;FLD1(x27,2)=x25;
  if(ISTGPRM(x7,1)){
   x30=x26;
   CPPRD(__AGenEvalMethod_20,1);
  }else{
   CPCLS(__AGenEvalMethod_18,1);
   CPCLS(__AGenEvalMethod_19,1);
   CPPRD(__AGenEvalMethod_20,1);
   {OBJ x28;OBJ x29;
    x28=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_18,1))(__AGenEvalMethod_18,__ABUILTIN_20);
    x29=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_19,1))(__AGenEvalMethod_19,__ABUILTIN_20);
    x30=_AMacros_52(x29,x28,x26);}}
  PRD1(2,x31);FLD1(x31,1)=x30;FLD1(x31,2)=x27;
  x32=_AMacros_51(__ASeq_6,x31);
  r=_AMacros_59(__AGenEvalMethod_20,__ABUILTIN_3,__ABUILTIN_3,x8,x18,__ANat_8,x32);}
 return r;}

extern OBJ _AGenEvalMethod_5(OBJ x1,OBJ x2,OBJ x3) /* genOverfullMethod */
{OBJ r;
 CPCLS(__AGenEvalMethod_21,1);
 CPCLS(__AGenEvalMethod_22,1);
 CPCLS(__AGenEvalMethod_23,1);
 CPCLS(__AGenEvalMethod_24,1);
 CPCLS(__AGenEvalMethod_25,1);
 CPPRD(__AMacros_9,1);
 CPCLS(__AMacros_12,1);
 CPPRD(__AMacros_141,1);
 {OBJ x4;OBJ x5;OBJ x6;OBJ x7;OBJ x8;OBJ x9;OBJ x10;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;OBJ x16;OBJ x17;OBJ x18;OBJ x19;OBJ x20;OBJ x21;OBJ x22;OBJ x23;OBJ x24;OBJ x25;OBJ x26;OBJ x34;OBJ x35;OBJ x36;
  ANat_2(x3,x4);
  ANat_62(x1,x2,x5);
  x6=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_22,1))(__AGenEvalMethod_22,__ABUILTIN_20);
  CPPRD(x6,2);
  ANat_76(x2,__ANat_5,x7);
  x8=_AMacros_74(x1,x2,x3);
  x9=_AMacros_12(x4);
  CPPRD(x9,2);
  x10=_ASeq_24(__ANat_8,x3,__AGenEvalMethod_21);
  x11=_ASeq_24(__ANat_8,x2,__AGenEvalMethod_23);
  x12=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_24,1))(__AGenEvalMethod_24,__ABUILTIN_20);
  x13=_ASeqMap_3(__AMacros_12,x10);
  COPY(x13,2);
  x14=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_25,1))(__AGenEvalMethod_25,x6);
  PRD1(2,x15);FLD1(x15,1)=x12;FLD1(x15,2)=__ASeq_6;
  x16=_AMacros_18(__AMacros_141,x9);
  x17=_ASeq_32(x5,x13);
  x18=_ASeq_31(x5,x13);
  x19=_ASeqMap_3(x14,x11);
  COPY(x19,1);
  PRD1(2,x20);FLD1(x20,1)=x16;FLD1(x20,2)=__ASeq_6;
  PRD1(2,x21);FLD1(x21,1)=x6;FLD1(x21,2)=x13;
  x22=_AMacros_33(x9,x17,__ANat_8);
  x23=_ASeq_26(x19,x18);
  x24=_AMacros_42(x22,__AMacros_9);
  x25=_AMacros_79(x6,x23,__ANat_8);
  x26=_AMacros_42(x25,x9);
  if(ISTGPRM(x7,1)){
   FREE(x19,1);
   CPPRD(__AGenEvalMethod_20,1);
   PRD(1,4,x34);FLD(x34,1)=x15;
  }else{
   CPCLS(__AGenEvalMethod_9,1);
   CPPRD(__AGenEvalMethod_20,1);
   CPCLS(__AGenEvalMethod_26,1);
   CPCLS(__AGenEvalMethod_27,1);
   {OBJ x27;OBJ x28;OBJ x29;OBJ x30;OBJ x31;OBJ x32;OBJ x33;
    x27=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_26,1))(__AGenEvalMethod_26,__ABUILTIN_20);
    x28=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_27,1))(__AGenEvalMethod_27,__ABUILTIN_20);
    PRD1(2,x29);FLD1(x29,1)=x27;FLD1(x29,2)=__ASeq_6;
    PRD(1,4,x30);FLD(x30,1)=x29;
    x31=_ASeqMap_3(__AGenEvalMethod_9,x19);
    x32=_ASeq_26(x31,x15);
    PRD(1,4,x33);FLD(x33,1)=x32;
    x34=_AMacros_52(x28,x30,x33);}}
  x35=_ASeq_15(x34,x26,x24);
  x36=_AMacros_51(x20,x35);
  r=_AMacros_59(__AGenEvalMethod_20,__ABUILTIN_3,__ABUILTIN_3,x8,x21,__ANat_8,x36);}
 return r;}

extern OBJ _AGenEvalMethod_6(OBJ x1,OBJ x2,OBJ x3) /* genFullMethod */
{OBJ r;
 {OBJ x4;OBJ x5;
  ANat_76(x3,__ANat_8,x4);
  x5=_AGenEvalMethod_7(x1,x2,x3);
  if(ISTGPRM(x4,1)){
   {OBJ x6;
    x6=_AGenEvalMethod_8(x1,x2,x3);
    PRD(1,4,r);
    FLD(r,1)=_ASeq_14(x5,x6);}
  }else{
   r=x5;}}
 return r;}

extern OBJ _AGenEvalMethod_7(OBJ x1,OBJ x2,OBJ x3) /* genPlainFullMethod */
{OBJ r;
 CPCLS(__AGenEvalMethod_28,1);
 CPCLS(__AGenEvalMethod_29,1);
 CPCLS(__AGenEvalMethod_30,1);
 CPCLS(__AGenEvalMethod_31,1);
 CPCLS(__AGenEvalMethod_32,1);
 CPPRD(__AMacros_9,1);
 CPCLS(__AMacros_12,1);
 {OBJ x4;OBJ x5;OBJ x6;OBJ x7;OBJ x8;OBJ x9;OBJ x10;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;OBJ x16;OBJ x28;
  x4=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_29,1))(__AGenEvalMethod_29,__ABUILTIN_20);
  CPPRD(x4,2);
  ANat_76(x2,__ANat_5,x5);
  x6=_AMacros_74(x1,x2,x3);
  x7=_ASeq_24(__ANat_8,x3,__AGenEvalMethod_28);
  x8=_ASeq_24(__ANat_8,x2,__AGenEvalMethod_30);
  x9=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_31,1))(__AGenEvalMethod_31,__ABUILTIN_20);
  x10=_ASeqMap_3(__AMacros_12,x7);
  COPY(x10,1);
  x11=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_32,1))(__AGenEvalMethod_32,x4);
  x12=_ASeqMap_3(x11,x8);
  COPY(x12,1);
  PRD1(2,x13);FLD1(x13,1)=x4;FLD1(x13,2)=x10;
  x14=_ASeq_26(x12,x10);
  x15=_AMacros_79(x4,x14,__ANat_8);
  x16=_AMacros_42(x15,__AMacros_9);
  if(ISTGPRM(x5,1)){
   FREE(x12,1);
   CPPRD(__AGenEvalMethod_20,1);
   {OBJ x17;
    x17=_ASeq_14(x9,x16);
    PRD(1,4,x28);FLD(x28,1)=x17;}
  }else{
   CPCLS(__AGenEvalMethod_9,1);
   CPPRD(__AGenEvalMethod_20,1);
   CPCLS(__AGenEvalMethod_33,1);
   CPCLS(__AGenEvalMethod_34,1);
   {OBJ x18;OBJ x19;OBJ x20;OBJ x21;OBJ x22;OBJ x23;OBJ x24;OBJ x25;OBJ x26;OBJ x27;
    x18=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_33,1))(__AGenEvalMethod_33,__ABUILTIN_20);
    x19=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_34,1))(__AGenEvalMethod_34,__ABUILTIN_20);
    PRD1(2,x20);FLD1(x20,1)=x9;FLD1(x20,2)=__ASeq_6;
    PRD1(2,x21);FLD1(x21,1)=x18;FLD1(x21,2)=__ASeq_6;
    PRD(1,4,x22);FLD(x22,1)=x21;
    x23=_ASeqMap_3(__AGenEvalMethod_9,x12);
    x24=_ASeq_26(x23,x20);
    PRD(1,4,x25);FLD(x25,1)=x24;
    x26=_AMacros_52(x19,x22,x25);
    x27=_ASeq_14(x26,x16);
    PRD(1,4,x28);FLD(x28,1)=x27;}}
  r=_AMacros_59(__AGenEvalMethod_20,__ABUILTIN_3,__ABUILTIN_3,x6,x13,__ANat_8,x28);}
 return r;}

extern OBJ _AGenEvalMethod_8(OBJ x1,OBJ x2,OBJ x3) /* genLazyFullMethod */
{OBJ r;
 CPCLS(__AGenEvalMethod_35,1);
 CPCLS(__AGenEvalMethod_36,1);
 CPCLS(__AGenEvalMethod_37,1);
 CPCLS(__AGenEvalMethod_40,1);
 CPCLS(__AGenEvalMethod_41,1);
 CPCLS(__AGenEvalMethod_42,1);
 CPPRD(__AMacros_9,1);
 CPCLS(__AMacros_12,1);
 CPPRD(__AMacros_81,1);
 {OBJ x4;OBJ x6;OBJ x7;OBJ x8;OBJ x9;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;OBJ x16;OBJ x17;OBJ x18;OBJ x19;OBJ x20;OBJ x21;OBJ x22;OBJ x34;
  x4=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_36,1))(__AGenEvalMethod_36,__ABUILTIN_20);
  CPPRD(x4,2);
  ANat_76(x2,__ANat_5,x6);
  x7=_AMacros_74(x1,x2,x3);
  x8=_ASeq_24(__ANat_8,x3,__AGenEvalMethod_35);
  x9=_ASeq_24(__ANat_8,x2,__AGenEvalMethod_37);
  x11=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_40,1))(__AGenEvalMethod_40,__ABUILTIN_20);
  x12=_ASeq_14(x7,__AMacros_81);
  x13=_ASeqMap_3(__AMacros_12,x8);
  COPY(x13,1);
  x14=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_41,1))(__AGenEvalMethod_41,x4);
  x15=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_42,1))(__AGenEvalMethod_42,__ABUILTIN_20);
  PRD(1,2,x16);FLD(x16,1)=x12;
  x17=_ASeqMap_3(x14,x9);
  COPY(x17,1);
  PRD(1,2,x18);FLD(x18,1)=x15;
  PRD1(2,x19);FLD1(x19,1)=x4;FLD1(x19,2)=x13;
  x20=_ASeq_26(x17,x13);
  x21=_AMacros_79(x4,x20,__ANat_8);
  x22=_AMacros_42(x21,__AMacros_9);
  if(ISTGPRM(x6,1)){
   FREE(x17,1);
   CPPRD(__AGenEvalMethod_20,1);
   {OBJ x23;
    x23=_ASeq_15(x11,x22,x18);
    PRD(1,4,x34);FLD(x34,1)=x23;}
  }else{
   CPPRD(__AGenEvalMethod_20,1);
   CPCLS(__AGenEvalMethod_43,1);
   CPCLS(__AGenEvalMethod_44,1);
   CPCLS(__AGenEvalMethod_45,1);
   {OBJ x24;OBJ x25;OBJ x26;OBJ x27;OBJ x28;OBJ x29;OBJ x30;OBJ x31;OBJ x32;OBJ x33;
    x24=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_44,1))(__AGenEvalMethod_44,__ABUILTIN_20);
    x25=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_45,1))(__AGenEvalMethod_45,__ABUILTIN_20);
    PRD1(2,x26);FLD1(x26,1)=x24;FLD1(x26,2)=__ASeq_6;
    PRD(1,4,x27);FLD(x27,1)=x26;
    x28=_ASeqMap_3(__AGenEvalMethod_43,x17);
    PRD(1,2,x29);FLD(x29,1)=x28;
    x30=_ASeq_15(x11,x29,x18);
    PRD(1,4,x31);FLD(x31,1)=x30;
    x32=_AMacros_52(x25,x27,x31);
    x33=_ASeq_14(x22,x32);
    PRD(1,4,x34);FLD(x34,1)=x33;}}
  r=_AMacros_59(__AGenEvalMethod_20,__ABUILTIN_3,__ABUILTIN_3,x16,x19,__ANat_8,x34);}
 return r;}

extern OBJ _AGenEvalMethod_9(OBJ x1) /* cCopy1 */
{OBJ r;
 r=_AMacros_47(x1,__AStore_32,__ANat_8);
 return r;}

extern OBJ _AGenEvalMethod_10(OBJ x1) /* genUnderfullMethod'10 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_11(OBJ x1) /* genUnderfullMethod'11 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_12(OBJ x1) /* genUnderfullMethod'12 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_13(OBJ x1) /* genUnderfullMethod'13 */
{OBJ r;
 r=_AMacros_12(__ANat_5);
 return r;}

extern OBJ _AGenEvalMethod_14(OBJ x1) /* genUnderfullMethod'14 */
{OBJ r;
 CPPRD(__AMacros_9,1);
 r=_AMacros_77(__AMacros_9,x1);
 return r;}

extern OBJ _AGenEvalMethod_15(OBJ x1) /* genUnderfullMethod'15 */
{OBJ r;
 CPPRD(__AMacros_9,1);
 r=_AMacros_77(__AMacros_9,x1);
 return r;}

extern OBJ _AGenEvalMethod_16(OBJ x1) /* genUnderfullMethod'16 */
{OBJ r;
 CPCLS(__AGenEvalMethod_13,1);
 CPPRD(__AMacros_9,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_13,1))(__AGenEvalMethod_13,__ABUILTIN_20);
  r=_AMacros_76(x2,__AMacros_9);}
 return r;}

extern OBJ _AGenEvalMethod_17(OBJ x1,OBJ x2) /* genUnderfullMethod'17 */
{OBJ r;
 r=_AMacros_77(x1,x2);
 return r;}

extern OBJ _AGenEvalMethod_18(OBJ x1) /* genUnderfullMethod'18 */
{OBJ r;
 CPCLS(__AGenEvalMethod_13,1);
 CPPRD(__AMacros_9,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_13,1))(__AGenEvalMethod_13,__ABUILTIN_20);
  r=_AMacros_42(x2,__AMacros_9);}
 return r;}

extern OBJ _AGenEvalMethod_19(OBJ x1) /* genUnderfullMethod'19 */
{OBJ r;
 CPCLS(__AGenEvalMethod_13,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_13,1))(__AGenEvalMethod_13,__ABUILTIN_20);
  r=_AMacros_75(x2);}
 return r;}

extern OBJ _AGenEvalMethod_21(OBJ x1) /* genOverfullMethod'21 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_22(OBJ x1) /* genOverfullMethod'22 */
{OBJ r;
 r=_AMacros_12(__ANat_5);
 return r;}

extern OBJ _AGenEvalMethod_23(OBJ x1) /* genOverfullMethod'23 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_24(OBJ x1) /* genOverfullMethod'24 */
{OBJ r;
 CPCLS(__AGenEvalMethod_22,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_22,1))(__AGenEvalMethod_22,__ABUILTIN_20);
  r=_AMacros_50(x2,__AStore_12,__ANat_8);}
 return r;}

extern OBJ _AGenEvalMethod_25(OBJ x1,OBJ x2) /* genOverfullMethod'25 */
{OBJ r;
 r=_AMacros_77(x1,x2);
 return r;}

extern OBJ _AGenEvalMethod_26(OBJ x1) /* genOverfullMethod'26 */
{OBJ r;
 CPCLS(__AGenEvalMethod_22,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_22,1))(__AGenEvalMethod_22,__ABUILTIN_20);
  r=_AMacros_49(x2,__AStore_12);}
 return r;}

extern OBJ _AGenEvalMethod_27(OBJ x1) /* genOverfullMethod'27 */
{OBJ r;
 CPCLS(__AGenEvalMethod_22,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_22,1))(__AGenEvalMethod_22,__ABUILTIN_20);
  r=_AMacros_75(x2);}
 return r;}

extern OBJ _AGenEvalMethod_28(OBJ x1) /* genPlainFullMethod'28 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_29(OBJ x1) /* genPlainFullMethod'29 */
{OBJ r;
 r=_AMacros_12(__ANat_5);
 return r;}

extern OBJ _AGenEvalMethod_30(OBJ x1) /* genPlainFullMethod'30 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_31(OBJ x1) /* genPlainFullMethod'31 */
{OBJ r;
 CPCLS(__AGenEvalMethod_29,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_29,1))(__AGenEvalMethod_29,__ABUILTIN_20);
  r=_AMacros_50(x2,__AStore_12,__ANat_8);}
 return r;}

extern OBJ _AGenEvalMethod_32(OBJ x1,OBJ x2) /* genPlainFullMethod'32 */
{OBJ r;
 r=_AMacros_77(x1,x2);
 return r;}

extern OBJ _AGenEvalMethod_33(OBJ x1) /* genPlainFullMethod'33 */
{OBJ r;
 CPCLS(__AGenEvalMethod_29,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_29,1))(__AGenEvalMethod_29,__ABUILTIN_20);
  r=_AMacros_49(x2,__AStore_12);}
 return r;}

extern OBJ _AGenEvalMethod_34(OBJ x1) /* genPlainFullMethod'34 */
{OBJ r;
 CPCLS(__AGenEvalMethod_29,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_29,1))(__AGenEvalMethod_29,__ABUILTIN_20);
  r=_AMacros_75(x2);}
 return r;}

extern OBJ _AGenEvalMethod_35(OBJ x1) /* genLazyFullMethod'35 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_36(OBJ x1) /* genLazyFullMethod'36 */
{OBJ r;
 r=_AMacros_12(__ANat_5);
 return r;}

extern OBJ _AGenEvalMethod_37(OBJ x1) /* genLazyFullMethod'37 */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AGenEvalMethod_38(OBJ x1) /* genLazyFullMethod'38 */
{OBJ r;
 CPPRD(__AMacros_9,1);
 r=_AMacros_47(__AMacros_9,__AStore_32,__ANat_8);
 return r;}

extern OBJ _AGenEvalMethod_39(OBJ x1) /* genLazyFullMethod'39 */
{OBJ r;
 CPCLS(__AGenEvalMethod_36,1);
 CPPRD(__AMacros_9,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_36,1))(__AGenEvalMethod_36,__ABUILTIN_20);
  r=_AMacros_80(x2,__AMacros_9);}
 return r;}

extern OBJ _AGenEvalMethod_40(OBJ x1) /* genLazyFullMethod'40 */
{OBJ r;
 CPCLS(__AGenEvalMethod_36,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_36,1))(__AGenEvalMethod_36,__ABUILTIN_20);
  r=_AMacros_50(x2,__AStore_12,__ANat_8);}
 return r;}

extern OBJ _AGenEvalMethod_41(OBJ x1,OBJ x2) /* genLazyFullMethod'41 */
{OBJ r;
 r=_AMacros_77(x1,x2);
 return r;}

extern OBJ _AGenEvalMethod_42(OBJ x1) /* genLazyFullMethod'42 */
{OBJ r;
 CPCLS(__AGenEvalMethod_38,1);
 CPCLS(__AGenEvalMethod_39,1);
 {OBJ x2;OBJ x3;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_38,1))(__AGenEvalMethod_38,__ABUILTIN_20);
  x3=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_39,1))(__AGenEvalMethod_39,__ABUILTIN_20);
  r=_ASeq_14(x2,x3);}
 return r;}

extern OBJ _AGenEvalMethod_43(OBJ x1) /* genLazyFullMethod'43 */
{OBJ r;
 CPPRD(__AMacros_22,1);
 r=_AMacros_42(__AMacros_22,x1);
 return r;}

extern OBJ _AGenEvalMethod_44(OBJ x1) /* genLazyFullMethod'44 */
{OBJ r;
 CPCLS(__AGenEvalMethod_36,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_36,1))(__AGenEvalMethod_36,__ABUILTIN_20);
  r=_AMacros_49(x2,__AStore_12);}
 return r;}

extern OBJ _AGenEvalMethod_45(OBJ x1) /* genLazyFullMethod'45 */
{OBJ r;
 CPCLS(__AGenEvalMethod_36,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGenEvalMethod_36,1))(__AGenEvalMethod_36,__ABUILTIN_20);
  r=_AMacros_75(x2);}
 return r;}

init_AGenEvalMethod()
{
 static int visited=0; if(visited) return; visited=1;
 init_ASetByBST();
 init_ABSTree();
 init_AArray();
 init_ANat();
 init_ATriple();
 init_APreparedOptions();
 init_ABoxedText();
 init_ASeq();
 init_ACom();
 init_AVoid();
 init_AStream();
 init_AOcOptions();
 init_AChar();
 init_AString();
 init_AFile();
 init_AInt();
 init_AOption();
 init_ASeqMap();
 init_ASeqReduce();
 init_ASeqZip();
 init_AStore();
 init_AMacros();
 init_ASet();
 init_AIde();
 init_ASourceAn();
 init_AFormat();
 init_AFmt();
 init_ANatMap();
 init_APair();
 init_ATree();
 init_ABitset();
 init_AMap();
 LCLS(1,_AGenEvalMethod_31,__AGenEvalMethod_31);
 CLS(1,_AGenEvalMethod_30,__AGenEvalMethod_30);
 LCLS(1,_AGenEvalMethod_29,__AGenEvalMethod_29);
 CLS(1,_AGenEvalMethod_28,__AGenEvalMethod_28);
 LCLS(1,_AGenEvalMethod_27,__AGenEvalMethod_27);
 LCLS(1,_AGenEvalMethod_26,__AGenEvalMethod_26);
 CLS(2,_AGenEvalMethod_25,__AGenEvalMethod_25);
 LCLS(1,_AGenEvalMethod_24,__AGenEvalMethod_24);
 CLS(1,_AGenEvalMethod_23,__AGenEvalMethod_23);
 LCLS(1,_AGenEvalMethod_22,__AGenEvalMethod_22);
 CLS(1,_AGenEvalMethod_21,__AGenEvalMethod_21);
 DEN("",__AGenEvalMethod_20);
 LCLS(1,_AGenEvalMethod_19,__AGenEvalMethod_19);
 LCLS(1,_AGenEvalMethod_18,__AGenEvalMethod_18);
 CLS(2,_AGenEvalMethod_17,__AGenEvalMethod_17);
 LCLS(1,_AGenEvalMethod_16,__AGenEvalMethod_16);
 CLS(1,_AGenEvalMethod_15,__AGenEvalMethod_15);
 CLS(1,_AGenEvalMethod_14,__AGenEvalMethod_14);
 LCLS(1,_AGenEvalMethod_45,__AGenEvalMethod_45);
 LCLS(1,_AGenEvalMethod_13,__AGenEvalMethod_13);
 LCLS(1,_AGenEvalMethod_44,__AGenEvalMethod_44);
 CLS(1,_AGenEvalMethod_12,__AGenEvalMethod_12);
 CLS(1,_AGenEvalMethod_43,__AGenEvalMethod_43);
 CLS(1,_AGenEvalMethod_11,__AGenEvalMethod_11);
 LCLS(1,_AGenEvalMethod_42,__AGenEvalMethod_42);
 CLS(1,_AGenEvalMethod_10,__AGenEvalMethod_10);
 CLS(2,_AGenEvalMethod_41,__AGenEvalMethod_41);
 CLS(1,_AGenEvalMethod_9,__AGenEvalMethod_9);
 LCLS(1,_AGenEvalMethod_40,__AGenEvalMethod_40);
 CLS(3,_AGenEvalMethod_8,__AGenEvalMethod_8);
 LCLS(1,_AGenEvalMethod_39,__AGenEvalMethod_39);
 CLS(3,_AGenEvalMethod_7,__AGenEvalMethod_7);
 LCLS(1,_AGenEvalMethod_38,__AGenEvalMethod_38);
 CLS(3,_AGenEvalMethod_6,__AGenEvalMethod_6);
 CLS(1,_AGenEvalMethod_37,__AGenEvalMethod_37);
 CLS(3,_AGenEvalMethod_5,__AGenEvalMethod_5);
 LCLS(1,_AGenEvalMethod_36,__AGenEvalMethod_36);
 CLS(3,_AGenEvalMethod_4,__AGenEvalMethod_4);
 CLS(1,_AGenEvalMethod_35,__AGenEvalMethod_35);
 LCLS(1,_AGenEvalMethod_34,__AGenEvalMethod_34);
 CLS(2,_AGenEvalMethod_2,__AGenEvalMethod_2);
 LCLS(1,_AGenEvalMethod_33,__AGenEvalMethod_33);
 CLS(2,_AGenEvalMethod_1,__AGenEvalMethod_1);
 CLS(2,_AGenEvalMethod_32,__AGenEvalMethod_32);}

